/**************************************************************************
 * $Id: DeviceType.h 1.1 Thu, 03 Dec 1998 12:49:42 +0100 samo $
 * $ReleaseVersion: 1.3.1 $
 *
 * This file is part of SampLin data acquisition software
 * Copyright (C) 1997,98 Samuel Kvasnica
 *
 * SampLin is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * SampLin is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file LICENSE) along with SampLin package; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **************************************************************************/

#ifndef DeviceType_included
#define DeviceType_included

#include "dlg/DeviceTypeData.h"

class DeviceType : public DeviceTypeData
{
    Q_OBJECT

public:

    DeviceType
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );

    virtual ~DeviceType();
   
   void setDevice(const char *str){input_device->setText(str);}
   void setHost(const char *str){input_host->setText(str);}
   void setTitle(const char *str){input_title->setText(str);}
   
   const char *getDevice(void){return(input_device->text());}
   const char *getHost(void){return(input_host->text());}
   const char *getTitle(void){return(input_title->text());}

};
#endif // DeviceType_included
