/**************************************************************************
 * $Id: GraphLegend.h 1.1 Thu, 03 Dec 1998 12:49:42 +0100 samo $
 * $ReleaseVersion: 1.3.1 $
 *
 * This file is part of SampLin data acquisition software
 * Copyright (C) 1997,98 Samuel Kvasnica
 *
 * SampLin is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * SampLin is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file LICENSE) along with SampLin package; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **************************************************************************/

#ifndef GraphLegend_included
#define GraphLegend_included

#include "dlg/GraphLegendData.h"
#include <SamplinPlot.h>

class GraphLegend : public GraphLegendData
{
    Q_OBJECT

 friend class GraphOptions;

 public:

    GraphLegend
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );

   virtual ~GraphLegend();
   void setData(SamplinPlot *);
   
 protected:
   SamplinPlot *series;
   
   QString d_comment;
   int d_lpos,d_cpos;
   QFont d_lfnt,d_cfnt,d_nlfnt,d_ncfnt;
   QColor d_lcolor,d_ccolor;

   void loadBack(void);
   void loadOld(void);
   
 protected slots:
   virtual void selectLFont();
   virtual void selectCFont();
   
};
#endif // GraphLegend_included
