/**************************************************************************
 * $Id: edit.h 1.1 Thu, 03 Dec 1998 12:49:42 +0100 samo $
 * $ReleaseVersion: 1.3.1 $
 *
 * This file is part of SampLin data acquisition software
 * Copyright (C) 1997,98 Samuel Kvasnica
 *
 * SampLin is free software; you can redistribute it and/or modify it
 * under the terms of the version 2 of GNU General Public License as
 * published by the Free Software Foundation.
 *
 * SampLin is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * (see the file LICENSE) along with SampLin package; if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 **************************************************************************/

#ifndef Edit_included
#define Edit_included

#include<qmlined.h>

class Edit : public QMultiLineEdit
{
    Q_OBJECT

 public:
    Edit
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );

    ~Edit();

   void insertAtEnd(const char *);
   void init(void);
   
 protected:
   
   void        keyPressEvent    ( QKeyEvent *  );
   void        mousePressEvent  ( QMouseEvent* );
   void        mouseReleaseEvent( QMouseEvent* );
   void        mouseMoveEvent   ( QMouseEvent* );
   
 signals:
   void cursorPosition_signal();
   void toggleOverwrite_signal();
};
#endif // Edit_included

