#ifndef __PCL812PGH
#define __PCL812PGH

#define  PCL_MAJOR  (42)      /*  The device major number.           */
#define  CONVERSION_TIME 1000 /*  1 usec */


#define  PCL_SET_MODE_CONTROL 1  /* IOctl no1: set mode (pooling,irq,dma) */
#define  PCL_SET_TIMER_CONTROL 2 /* IOctl no2: set timer control */
#define  PCL_SET_GAIN 3		 /* IOctl no3: set pcl gain   */
#define  PCL_GET_TIMER_CONTROL 4


#define  PCL_READ_COUNTER0 5
#define  PCL_READ_COUNTER1 6
#define  PCL_READ_COUNTER2 7


#define  PCL_SET_COUNTER0 8
#define  PCL_SET_COUNTER1 9
#define  PCL_SET_COUNTER2 10

#define  PCL_SET_MODE_POLLING 1
#define  PCL_SET_MODE_INTERRUPT 6 
#define  PCL_SET_MODE_DMA 2	

#define  PCL_COUNTER0 0
#define  PCL_COUNTER1 0x40
#define  PCL_COUNTER2 0x80

#define  PCL_COUNTER_LATCH 0
#define  PCL_COUNTER_RW_LSB 0x10
#define  PCL_COUNTER_RW_MSB 0x20
#define  PCL_COUNTER_RW_LSB_MSB 0x30

#define	 PCL_COUNTER_INT 0x00		/* Interrupt on terminal count */
#define	 PCL_COUNTER_ONE_SHOT 0x02      /* Programable one shot        */
#define  PCL_COUNTER_RATE_GEN 0x04 	/* Rate generator	       */
#define  PCL_COUNTER_SQUARE_WAVE 0x06   /* Square wave generator       */
#define  PCL_COUNTER_SOFT_TRIGGER 0x08  /* Software trigger strobe     */
#define  PCL_COUNTER_HARD_TRIGGER 0x0A  /* Hardware trigger strobe     */

#define  PCL_COUNTER_BINARY 0		/* 16 bit counter	       */
#define  PCL_COUNTER_BCD    1		/* BCD counter                 */   

#define  DMA_BUFFER	4096		/* For DMA transfers	       */
#endif 

















